/*
Program: poly-integer-root-v1.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: ĤG椸q21m
Note: whܤ覡A{Įѥpolynomial.c覡ɤJDummyF{iܤ@ӹ@覡A
	  ϥDummyiĹB@AѦPǰѦҹB 
*/

#include <stdio.h>
#include <stdlib.h>	/* for malloc(), abs() */
#include <math.h>	/* for pow() */

int findRoot(int p[], int q[])	/* pGJhFqGDoƮ */ 
{
	int r, c = 0, i, j, k, sum;
	int sign[2] = {1,-1};
	
	if (p[2*p[0]]%p[2] != 0) return 0; /* h`ƶYQ̰Yƾ㰣(Ĵp2x^2 - 3 = 0)AhsbƸ */ 
	
	r = abs(p[2*p[0]]/p[2]);		/* rGMhYƪ]ơAتO̰Y²Ƭ1ӱ`ƶ²ƬrAHQB */ 
	for (i = 1; i <= r; i++) {		/* Ҽ{rҦ]iAYinOhƬ0AhӦ]iYҨDѤ@ */ 
		if (r%i != 0) continue;		/* iLk㰣rAiOr]ơAGLA~Ҽ{U@i */ 
		for (j = 0; j < 2; j++) {	/* ɤJ2^XjY]iiOѡAj0ANҼ{+iҡFj1ANҼ{-ip */
			for (sum = 0, k = 1; k <= 2*p[0]; k+=2)	/* pC@G(Y*x^)ò֥[sum */ 
				sum += p[k+1]*(int)(pow(sign[j]*i,p[k]));	/* iȥHsign[j]*i{ANJhD */ 
			if (sum == 0) q[c++] = sign[j]*i;	/* bingo! o{XG󪺾ƮڡANgJq}C */
		}
	}
	
	return c;	/* ^ǸѪӼ */ 
}

void show(int p[], int n, int mode)	/* Jp}CiyzhA]iNƮڪeANmodeϤtƪBz覡 */ 
{
	int i;
	
	if (mode == 0) {	/* mode0ANpNQŪhyzTANܸӦh */
		printf("{p(x)= ");
		for (i = 1; i <= n; i += 2) {
			if (abs(p[i+1])>1) 		/* YƤ1 */ 
				printf("%s%d",p[i+1]>1? "":"\b", p[i+1]);	/* YY>1AiܫYƭȡFYYƬtAhЭ˰h@AܫYƭ(eɪ'+') */ 
			else if (p[i+1]==-1)	/* YƬ-1 */ 
				printf("\b-");		/* Э˰h@AHȦA'-'Yi(eɪ'+')(ܬ'-1') */
			/* YƭY1AhB~ʧ@FOdeɪ'+'Aݥt@ */ 
			switch(p[i]) {			/* switch[cBzCӶƪ */ 
				case 0: 			/* ӶƬ0AN`ƶAx^0AG'+'AU@X@ǳ */ 
					printf("+");
					break;
				case 1:
					printf("x+");	/* ӶƬ1Ax^1AG'x+'AU@X@ǳ */
					break;
				default:
					printf("x^%d+",p[i]);	/* x^n+ΦAU@X@ǳ */
			}		
		}
		printf("\b ");	/* ̫hl'+'Hťն */ 
	}
	else {	/* mode1ANpNQŪhڡANܮڪe */
		for (i = 0; i < n; i++) printf("%dB",p[i]);	/* CqX@ӮڡAtܹy */ 
		if (n > 0) printf("\b\b  ");	/* ̫ܦhlyHЭ˰hG檺覡Hťն */ 
	}
}

int main()
{
	int p[] = {4,3,1,2,-2,1,-1,0,2};
	//int p[] = {4,3,3,2,-6,1,-3,0,6};
	//int p[] = {2,2,1,0,-100};
	//int p[] = {4,3,1,2,-7,1,4,0,12};
	//int p[] = {5,4,1,3,3,2,-66,1,52,0,120};
	//int p[] = {5,4,3,3,9,2,-198,1,156,0,360};
	int c, *q = (int *)malloc(p[1]*sizeof(int)); /* p[1]̰ơA̦ȳЫبŶ}CsҨDoƮ */ 
	/* c: DoƮڪӼơANfindRoot()^ǪڭӼơF
	   q: sDoکҥΰ}CAڪӼƳ̦hPh̰ƬۦPAHpݩʰʺAtmһݰOŶ */ 
	
	printf("\n*** ѦhƮ ***\n\n");
	show(p,2*p[0],0);	/* qXHpyzhA2*p[0]NyzDsҥΪƭȭӼơAĤT޼0XҦ(ԨUshow()wq) */ 
	c = findRoot(p,q);	/* Dڵ{ǡAJpҴyzhAqNDoڡAfindRoot()^ǲŦXڭӼ */ 
	if (c > 0) {
		printf("\n\nѱoƮڬG");
		show(q,c,1);  	/* qXqeAcڪӼơAĤT޼1NIsshow()Bһݪu@Ҧ */ 
	}
	else
		printf("\n\nƮڤsb\n");
	
	free(q);
	return 0;
}
