/*
Program: poly-integer-root-v3.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: phƮڡA{LJhAXGJhH̺²Φe{(YƻPƭY1iٲ)
	ABܸѱoƮڡFYƮڤsbAhܰTi
Notes:
	1) ipoly-integer-root-v2.cBץG{58檺~PAϯɥiaDoƮڡAӫDOҦڧƤ~⦳ 
	2) {iBzhsb`ƶ 
	3) LJΦi 
		1x^2-100x^0
		1x^3-2x^2-1x^1+2x^0
		1x^3-7x^2+4x^1+12x^0
		1x^4+3x^3-66x^2+52x^1+120x^0
		3x^4+9x^3-198x^2+156x^1+360x^0
		1x^2-1x^1
		2x^ 3 -201 x^2+ 97 x^1 +300
		2x^12-195x^11-500x^10
		6x^4 - 1x^3 -25x^2 + 4x^1 + 4 
*/

#include <stdio.h>
#include <stdlib.h>	/* for malloc() */
#include <math.h>	/* for pow() */

#define MAX 256

void compact(char str[]) /* strťաAܱo */ 
{
    int i, j;
    
    for (i = j = 0; str[i]; i++, j++) {
    	for (; str[i]==' '; i++);
    	str[j] = str[i];
	}
	str[j] = '\0';
	printf("\nťի᪺rG%s\n",str);
}

int readPoly(int p[])	/* ŪJB⦡rAUƻPYƤOxs}CA^ǫDsӼ */ 
{
	int  i = 1, argCount;
	char str[MAX];
	
	gets(str); /* ĳ fgets(str,MAX,stdin) HקKyJƹLӳyLwİzͿ~ */ 
	compact(str); /* strťաAܱo */ 
	
	do { 
    	if ((argCount=sscanf(str,"%dx^%d%s",&p[i+1],&p[i],str))==2) break; /* qstruŪ2ӼƾڡA, A]SFi(sJstr)ANrwŪɡANj */ 
		if (argCount == 1) {	/* ̥Ū`ƪܦAĴp 3  -5 (g3x^0Bz) */
    		p[i] = 0;
    		break;
		}
      	i += 2;
  	} while (1); 
	
	return (p[0] = (i+1)/2);
}

int findRoot(int p[], int q[]) /* ڡAұoѦsJq[]A^ǮڪӼ */ 
{
	int r, c = 0, i, j, k, sum;
	int sign[2] = {1,-1};
	
	if (p[2*p[0]-1] != 0) { /* ̧C >= 1Ah0i */ 
		if ((i=p[2*p[0]-1]) > 0) q[c++] = 0;	/* ̧CƳ]i */
		for (j = 1; j < 2*p[0]; j+=2) p[j] -= i;/* Ҧƴhi */ 
	}
	
	r = abs(p[2*p[0]]);				/* X̧CY */
	for (i = 1; i <= r; i++) {		/* Ҽ{㰣r]iA`Nt */ 
		if (r%i != 0) continue;		/* 㰣riNLA~Ҽ{U@i */ 
		for (j = 0; j < 2; j++) {	/* j0ANҼ{+iҡFj1ANҼ{-ip */
			for (sum = 0, k = 1; k <= 2*p[0]; k+=2)	/* pC@G(Y*x^)ò֥[sum */ 
				sum += p[k+1]*(int)(pow(sign[j]*i,p[k]));
			if (sum == 0) q[c++] = sign[j]*i;  /* bingo! o{XG󪺾ƮڡANgJq}C */ 
		}
	}
	
	return c;
}

void show(int p[], int n, int mode)
{
	int i;
	
	if (mode == 0) { /* ܤ{ */ 
		printf("{p(x)= ");
		for (i = 1; i <= n; i += 2) {
			if (abs(p[i+1])>1) 		/* Y>1<-1AhܸӫYƭ */ 
				printf("%s%d",p[i+1]>1? "":"\b",p[i+1]);	/* YYƬtȡAeɪ+ */ 
			else if (p[i+1]==-1)	/* YƬ-1A-Yi */ 
				printf("%s",p[i]==0? "\b-1":"\b-");
			switch(p[i]) {
				case 0: 
					printf("+");
					break;
				case 1:
					printf("x+");
					break;
				default:
					printf("x^%d+",p[i]);
			}		
		}
		printf("\b ");
	}
	else { /* mode==1Aܩұo */ 
		for (i = 0; i < n; i++) printf("%dB",p[i]);
		if (n > 0) printf("\b\b  ");
	}
}

int main()
{
	int p[101] = {0};
	int c, *q; 
	
	printf("\n*** ѦhƮ ***\n\nJh ==> ");
	c = readPoly(p);
	q = (int *)malloc(p[1]*sizeof(int)); /* p[1]̰ơA̦ȳЫبŶ}CsҨDoƮ */ 
	show(p,2*p[0],0);
	c = findRoot(p,q);
	if (c > 0) {
		printf("\n\nѱoƮڬG");
		show(q,c,1);  
	}
	else
		printf("\n\nƮڤsb\n");
	
	free(q);
	return 0;
}
